#include "NRF24L01.h"

/*Դ
ͳã
if(NRF24L01_RxPacket(Rx_BUF) == 0)
if(NRF24L01_TxPacket(Tx_BUF) == TX_OK)
while(1)
{
	NRF24L01_CE_L(); NRF24L01_CSN_L(); 
	delay_ms(1000);
	NRF24L01_CE_H(); NRF24L01_CSN_H3e(); 
	delay_ms(1000);
} */
	
u8  TX_ADDRESS[TX_ADR_WIDTH]= {0xAA,0xBB,0xCC,0xDD,0xEE}; //{0xE1,0xE2,0xE3,0xE4,0xE5};	//صַ
u8  RX_ADDRESS[RX_ADR_WIDTH]= {0xAA,0xBB,0xCC,0xDD,0xEE}; //{0xE1,0xE2,0xE3,0xE4,0xE5};	//յַ

//ʼ24L01IO
void NRF24L01_Init(void)
{ 	
	NRF24L01_CE_L(); //ʼŵĳʼƽ
	NRF24L01_CSN_H();
	
	SPI3_Init();
	//EXTI_NRF_Init();//ж	(IRQ -- PD4)
}

//οϣSTM32ȫֲ_⺯汾_V3.1.pdf  pdf -- 175
void EXTI_NRF_Init(void)
{
		EXTI_InitTypeDef EXTI_InitStructure; //NRFж 
	
		EXTI_ClearITPendingBit(EXTI_Line4);  //ⲿж4ӵPD4 
		GPIO_EXTILineConfig(GPIO_PortSourceGPIOD, GPIO_PinSource4); //˿жӳ

		EXTI_InitStructure.EXTI_Line = EXTI_Line4; 
		EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
		EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
		EXTI_InitStructure.EXTI_LineCmd = ENABLE;
		EXTI_Init(&EXTI_InitStructure);
}

//24L01Ƿ
u8 NRF24L01_Check(void)
{
	u8 i,buf[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
 	 
	//SPI3_SetSpeed(SPI_BaudRatePrescaler_8); //spi ٶΪ 9Mhz !!!!!
	NRF24L01_Write_Buf(WRITE_REG_NRF+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	NRF24L01_Read_Buf(TX_ADDR,buf,5); //дĵַ  
	
	for(i=0;i<5;i++)if(buf[i]!=0XA5)break;	 							   
	if(i!=5)return 0;//24L01	
	return 1;		 //⵽24L01
}	 	 

//SPIдĴ
u8 NRF24L01_Write_Reg(uint8_t reg,uint8_t value)
{
	  u8 status;	
   	NRF24L01_CSN_L();                 //ʹSPI
  	status =SPI3_ReadWriteByte(reg);//ͼĴ 
  	SPI3_ReadWriteByte(value);      //дĴֵ
  	NRF24L01_CSN_H();                 //ֹSPI	   
  	return(status);       			//״ֵ̬
}

//ȡSPIĴֵ
u8 NRF24L01_Read_Reg(u8 reg)
{
	  u8 reg_val;	    
 	  NRF24L01_CSN_L();;          //ʹSPI		
  	SPI3_ReadWriteByte(reg);   //ͼĴ
  	reg_val=SPI3_ReadWriteByte(0XFF);//ȡĴ
  	NRF24L01_CSN_H();;          //ֹSPI		    
  	return(reg_val);           //״ֵ̬
}	

//ָλöָȵ
u8 NRF24L01_Read_Buf(u8 reg,u8 *pBuf,u8 len)
{
	  u8 status,u8_ctr;	       
  	NRF24L01_CSN_L();           //ʹSPI
  	status=SPI3_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬   	   
 	  for(u8_ctr=0;u8_ctr<len;u8_ctr++)pBuf[u8_ctr]=SPI3_ReadWriteByte(0XFF);//
  	NRF24L01_CSN_H();       //رSPI
  	return status;        //ض״ֵ̬
}

//ָλдָȵ
u8 NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 len)
{
	  u8 status,u8_ctr;	    
 	  NRF24L01_CSN_L();          //ʹSPI
  	status = SPI3_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬
  	for(u8_ctr=0; u8_ctr<len; u8_ctr++)SPI3_ReadWriteByte(*pBuf++); //д	 
  	NRF24L01_CSN_H();       //رSPI
  	return status;          //ض״ֵ̬
}				   

//NRF24L01һ
u8 NRF24L01_TxPacket(u8 *txbuf)
{
 	SPI3_SetSpeed(SPI_BaudRatePrescaler_16);//spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	
	NRF24L01_CE_L();  //StandBy Iģʽ	
  NRF24L01_Write_Buf(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ  
  NRF24L01_CE_H();	//øCEݷ
	
#if Single_Com == 1
	u8 sta;
	
	while(NRF24L01_IRQ!=0);//ȴ
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ;
	NRF24L01_Write_Reg(WRITE_REG_NRF+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_TX)//ﵽط
	{
		NRF24L01_Write_Reg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
	}
	if(sta&TX_OK)//
	{
		return TX_OK;
	}
	return 0xff;//ԭʧ
	
#else
	return 0;
#endif
}

void NRF24L01_TxPacket_AP(u8 *txbuf)
{
	SPI3_SetSpeed(SPI_BaudRatePrescaler_16);//spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	
	NRF24L01_CE_L();  //StandBy Iģʽ	
  NRF24L01_Write_Buf(0xA8,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ  
  NRF24L01_CE_H();	//øCEݷ
}

//NRF24L01һ
u8 NRF24L01_RxPacket(u8 *rxbuf)
{
#if Single_Com == 1
	u8 sta;		    							   
	SPI3_SetSpeed(SPI_BaudRatePrescaler_32); //spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ    	 
	NRF24L01_Write_Reg(WRITE_REG_NRF+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&RX_OK)//յ
	{
		NRF24L01_Read_Buf(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
		NRF24L01_Write_Reg(FLUSH_RX,0xff);//RX FIFOĴ 
			GPIO_SetBits(GPIOE, GPIO_Pin_15 );	
		return 0; 
	}
 	return 1;//ûյκ
#else
	return 0;
#endif
}					    

//2401ģʽ
void NRF24L01_Mode(u8 model)
{
	 NRF24L01_CE_L();     
   NRF24L01_Write_Buf(WRITE_REG_NRF+TX_ADDR,(u8*)TX_ADDRESS,TX_ADR_WIDTH);//дTXڵַ 
   NRF24L01_Write_Buf(WRITE_REG_NRF+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK	  

   NRF24L01_Write_Reg(WRITE_REG_NRF+EN_AA,0x01);     //ʹͨ0ԶӦ    00ʾӦ
   NRF24L01_Write_Reg(WRITE_REG_NRF+EN_RXADDR,0x01); //ʹͨ0Ľյַ  Ϊ0
   NRF24L01_Write_Reg(WRITE_REG_NRF+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10 ط
   NRF24L01_Write_Reg(WRITE_REG_NRF+RF_CH,50);       //0x73   RFͨΪ40ŵΪ2.5GHZշһ
   NRF24L01_Write_Reg(WRITE_REG_NRF+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪  

	if(model==1)				//RX
	{
		NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 
		NRF24L01_Write_Reg(WRITE_REG_NRF + CONFIG, 0x0f);   		 // IRQշжϿ,16λCRC,
	}
	else if(model==2)		//TX
	{
		NRF24L01_Write_Reg(WRITE_REG_NRF+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 
		NRF24L01_Write_Reg(WRITE_REG_NRF + CONFIG, 0x0e);   		 // IRQշжϿ,16λCRC,
	}
	else if(model==3)		//RX2
	{
		NRF24L01_Write_Reg(FLUSH_TX,0xff);
		NRF24L01_Write_Reg(FLUSH_RX,0xff);
		NRF24L01_Write_Reg(WRITE_REG_NRF + CONFIG, 0x3f); //0f  		 // IRQշжϿ,16λCRC,0x0f
																													//λΪ3ʾηж
		SPI3_ReadWriteByte(0x50);
		SPI3_ReadWriteByte(0x73);
		NRF24L01_Write_Reg(WRITE_REG_NRF+0x1c,0x01);
		NRF24L01_Write_Reg(WRITE_REG_NRF+0x1d,0x07);  //06
	}
	else								//TX2
	{
		NRF24L01_Write_Reg(WRITE_REG_NRF + CONFIG, 0x2e);  //0e 		 // IRQշжϿ,16λCRC,0x0e
		NRF24L01_Write_Reg(FLUSH_TX,0xff);											//λbit4MAX_RT bit5 Ϊ1TX_DS bit6 RX_DS
		NRF24L01_Write_Reg(FLUSH_RX,0xff);											//ڷɿأģʽ2eǺõ
		
		SPI3_ReadWriteByte(0x50);
		SPI3_ReadWriteByte(0x73);
		NRF24L01_Write_Reg(WRITE_REG_NRF+0x1c,0x01);
		NRF24L01_Write_Reg(WRITE_REG_NRF+0x1d,0x07); //06
	}
	NRF24L01_CE_H(); 
}

//NRF24L01һ֡
u8 tempbuf[64];
u8 NRF24L01_Txframes(u8 *txbuf,u8 packlen)
{
	u8 txresult;
	//ʼʹ֡
	txresult=NRF24L01_TxPacket(txbuf);
  if(packlen>32)
	  txresult=NRF24L01_TxPacket(&txbuf[32]);

  if(packlen>64)
	  txresult=NRF24L01_TxPacket(&txbuf[64]);

  if(packlen>96)txresult=!TX_OK;//ݳȴ96ΪǴ֡

	if(txresult==TX_OK)//
	{
		return 1;
	}
	return 0;//ԭʧ
}

void NRF24L01_Check_Event(void)
{
	u8 sta;
	SPI3_SetSpeed(SPI_BaudRatePrescaler_32);
	sta = NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ;

	if(sta & RX_OK) //յ
	{
		u8 Rx_Len = NRF24L01_Read_Reg(R_RX_PL_WID);
		if(Rx_Len<33)
		{
			NRF24L01_Read_Buf(RD_RX_PLOAD,Rx_BUF,RX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
			//
		}else NRF24L01_Write_Reg(FLUSH_RX,0xff);//ջ
	}
	if(sta & TX_OK)
	{
		
	}
	if(sta & MAX_TX)
	{
		if(sta & 0x01)	//TX FIFO FULL
			NRF24L01_Write_Reg(FLUSH_TX,0xff);
	}
	NRF24L01_Write_Reg(WRITE_REG_NRF+STATUS,sta); //TX_DSMAX_RTжϱ־
}

